giv <-
function(R){
  zero <- 1e-12
  m <- nrow(R)
  n <- ncol(R)
  Q <- diag(1,m)
  for(i in 1:n){
    if(abs(R[i,i])<zero){
      for(j in i:n){
        if(abs(R[i,j])>zero){
          for(k in j:n){
            if(abs(R[k,j])>zero){   
              c <- ((R[i,j])^2+(R[k,j])^2)^0.5
              s <- R[k,j]/c
              c <- R[i,j]/c
              for(l in j:n){
                tmp1 <- -s*R[i,l]+c*R[k,l]
                tmp2 <- c*R[i,l]+s*R[k,l]
                R[i,l] <- tmp1
                R[k,l] <- tmp2
              }
              for(l in 1:m){
                tmp1 <- -s*Q[i,l]+c*Q[k,l]
                tmp2 <- c*Q[i,l]+s*Q[k,l]
                Q[i,l] <- tmp1
                Q[k,l] <- tmp2
              }
              break 
            }
          }
        } 
      }
    }  
  }
  a <- list(Q2=Q,R2=R)
  return(a)
}
