hld <-
function(A){
  m <- nrow(A)
  n <- ncol(A)
  Q <- diag(1,m)
  R <- A
  for(j in 1:n){
    normx <- Norm(R[j:m,j])
    if(normx<1e-6){next}
    if(R[j,j]==0){ 
      for(i in (j+1):m){
        if(R[i,j]!=0){
          tmp <- R[j,]
          R[j,] <- R[i,]
          R[i,] <- tmp 
          tmp <- Q[,j]
          Q[,j] <- Q[,i]
          Q[,i] <- tmp 
          break
        }
      }
    }       
    s <- -sign(R[j,j])
    u1 <- R[j,j]-s*normx
    w <- R[j:m,j]/u1
    w[1] <- 1
    tau <- -s*u1/normx
    R[j:m,] <- R[j:m,]-(tau*w) %*% (t(w) %*% R[j:m,])
    Q[j:m,] <- Q[j:m,]-(tau*w) %*% (t(w) %*% Q[j:m,])
  }
  a <- list(Q1=Q,R1=R)
  return(a)
}
