\name{inv}
\alias{inv}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Matrix Inverse
}
\description{
Invert a numeric or complex matrix.
}
\usage{
inv(a)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{a}{
real or complex square matrix
}
}
\details{
Computes the matrix inverse by calling solve(a) and catching the error if the matrix is nearly singular.
}
\value{
square matrix that is the inverse of a.
}
\references{
None
}
\author{
wangdeyuan \email{wcndy2007@163.com}
}
\note{
inv() is the function name used in Matlab/Octave.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
None
}
\examples{
A <- hilb(6)
B <- inv(A)
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (a) 
{
    if (length(a) == 0) 
        return(matrix(0, nrow = 0, ncol = 0))
    if ((!is.numeric(a) && !is.complex(a)) || !is.matrix(a)) 
        stop("Argument 'a' must be a numeric or complex matrix.")
    if (nrow(a) != ncol(a)) 
        stop("Matrix 'a' must be square.")
    e <- try(b <- solve(a), silent = TRUE)
    if (class(e) == "try-error") {
        warning("Matrix appears to be singular.")
        b <- rep(Inf, length(a))
        dim(b) <- dim(a)
    }
    return(b)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ Matrix }
\keyword{ Inverse }% __ONLY ONE__ keyword per line
